
.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include TreeViewCBRB.inc

.code

start:

	invoke	GetModuleHandle, NULL
	mov		hInstance, eax
    invoke	InitCommonControls
	invoke	DialogBoxParam, hInstance, IDD_MAINDIALOG, NULL, addr DlgProc, NULL
	invoke	ExitProcess,0


DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	tvis			:TV_INSERTSTRUCT
	LOCAL	tvi				:TV_ITEM
	LOCAL	tvhti			:TV_HITTESTINFO
	LOCAL	pt				:POINT	
	
	;LOCAL	hTrvParent		:DWORD
	LOCAL	hTempItem		:DWORD
	LOCAL	hImgList		:DWORD

	
	.if uMsg==WM_INITDIALOG
		
		invoke	LoadIcon, hInstance, IDR_MAINICON
		invoke	SendMessage, hWnd, WM_SETICON, ICON_SMALL, eax
		
		invoke	GetDlgItem, hWnd, IDC_MAINTRV
		mov		hMainTreeView, eax
		

		invoke	ImageList_Create, 16, 16, ILC_MASK or ILC_COLORDDB, 20, 20 
	       mov	hImgList, eax
	    invoke	LoadBitmap, hInstance, IDR_TREEVIEWIMG2
	    invoke	ImageList_AddMasked, hImgList, eax, 00FF00FFh
	    invoke	SendMessage, hMainTreeView, TVM_SETIMAGELIST, 0, hImgList
	
		invoke InsertRoot,hMainTreeView,addr szSet1
		
		invoke InsertItems,hMainTreeView,addr szTxt1
		invoke InsertItems,hMainTreeView,addr szTxt2
		invoke InsertItems,hMainTreeView,addr szTxt3
        
        invoke InsertRoot,hMainTreeView,addr szSet2
	    invoke InsertItems,hMainTreeView,addr szTxt4
	    invoke InsertItems,hMainTreeView,addr szTxt5
	    invoke InsertItems,hMainTreeView,addr szTxt6
	    invoke InsertItems,hMainTreeView,addr szTxt7

		
	.elseif uMsg==WM_COMMAND
		
		mov		edx, wParam
		movzx	eax, dx
		shr		edx, 16
		
		.if edx==BN_CLICKED
			.if eax==1002
		    	push	ebx
				mov		tvi._mask, TVIF_HANDLE or TVIF_IMAGE or TVIF_SELECTEDIMAGE
				invoke	SendDlgItemMessage, hWnd, IDC_MAINTRV, TVM_GETNEXTITEM, TVGN_ROOT, 0
				.if	eax
		               mov tvi.hItem,eax
		               mov tvi.imask,TVIF_TEXT
		               mov eax,offset lpBuffer
		               mov tvi.pszText,eax
		               mov tvi.cchTextMax,MAX_PATH
		            invoke SendMessage,hMainTreeView,TVM_GETITEM,0,addr tvi
		            .if	eax
			            invoke MessageBox,0,addr lpBuffer,0,MB_OK
			               mov eax,tvi.hItem
		          
				        invoke	SendDlgItemMessage, hWnd, IDC_MAINTRV, TVM_GETNEXTITEM, TVGN_CHILD, eax
				           mov	tvi.hItem, eax
			
				        invoke	SendDlgItemMessage, hWnd, IDC_MAINTRV, TVM_GETITEM, 0, addr tvi
				        .if tvi.iImage==2
					        invoke MessageBox,0,addr lpBuffer,0,MB_OK
				        .endif
				        invoke	SendDlgItemMessage, hWnd, IDC_MAINTRV, TVM_GETNEXTITEM, TVGN_NEXT, tvi.hItem
				        mov	tvi.hItem, eax
				        pop	ebx
			        .endif
			    .endif
            .endif
		.endif
		
	.elseif uMsg==WM_NOTIFY
		
		.if wParam==IDC_MAINTRV
			
			push	ebx
			mov 	ebx, lParam
			.if [ebx+NMHDR.code]==NM_CLICK ; for CheckBoxes
				invoke	GetCursorPos, addr pt
				invoke	ScreenToClient, hMainTreeView, addr pt
				mov		tvhti.flags, TVHT_ONITEM
				m2m		tvhti.pt.x, pt.x
				m2m		tvhti.pt.y, pt.y
				invoke	SendDlgItemMessage, hWnd, IDC_MAINTRV, TVM_HITTEST, 0, addr tvhti
				mov		eax, tvhti.hItem
				mov		tvi.hItem, eax
				mov		tvi._mask, TVIF_HANDLE or TVIF_IMAGE or TVIF_SELECTEDIMAGE
				invoke	SendDlgItemMessage, hWnd, IDC_MAINTRV, TVM_GETITEM, 0, addr tvi
				.if tvi.iImage==1
					mov		tvi.iImage, 2
					mov		tvi.iSelectedImage, 2
				.elseif tvi.iImage==2
					mov		tvi.iImage, 1
					mov		tvi.iSelectedImage, 1
				.endif
				invoke	SendDlgItemMessage, hWnd, IDC_MAINTRV, TVM_SETITEM, 0, addr tvi
			.endif
			pop		ebx
		.endif
		
	.elseif uMsg==WM_CLOSE
		
		invoke	EndDialog, hWnd, 0
		
	.else
		
		mov		eax, FALSE
		ret
		
	.endif
	
	mov		eax, TRUE
	ret

DlgProc endp

InsertRoot proc uses edi hWnd:HWND,lpszRootName:DWORD
LOCAL	tvis			:TV_INSERTSTRUCT

	   mov  tvis.itemex.imask, TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
	   mov  tvis.itemex.cchTextMax, 255
	   mov  tvis.hParent, 0
	   mov  tvis.hInsertAfter, TVI_ROOT
	   mov  tvis.itemex.iImage, 0
	   mov  tvis.itemex.iSelectedImage,0
	   mov  edi,lpszRootName
       mov  tvis.itemex.pszText, edi
	invoke	SendMessage, hWnd, TVM_INSERTITEM, 0, addr tvis
	   mov	hTrvParent, eax
	   ret
InsertRoot endp

InsertItems proc uses edi hWnd:HWND,lpszItemName:DWORD
LOCAL	tvis			:TV_INSERTSTRUCT	
	   mov  eax,hTrvParent
	   mov  tvis.hParent,eax
	   mov	tvis.itemex.iImage, 2
	   mov	tvis.itemex.iSelectedImage, 2
	   mov  edi,lpszItemName
	   mov	tvis.itemex.pszText,edi
	invoke	SendMessage, hWnd, TVM_INSERTITEM, 0, addr tvis
	   ret
InsertItems endp


end start


